#!/usr/bin/python# 
# This Python file uses the following encoding: utf-8
# This is server.py file version 99r RPi zero

import sys, logging, time
from PIL import Image,ImageDraw,ImageChops,ImageEnhance,ImageFont
from time import localtime, strftime

logging.basicConfig(filename='/var/www/html/led/led_daemon.log',level=logging.DEBUG)

from rgbmatrix import RGBMatrix, RGBMatrixOptions


#Déclarations pour éviter de passer le chemin absolu via php
CheminFichierCommande="/var/www/html/led/"
CheminFichierConfig="/var/www/html/led/"
CheminDossierImages="/var/www/html/led/images/"
CheminDossierPolices="/var/www/html/led/fonts/"

#Logging
logging.getLogger("PIL").setLevel(logging.WARNING)
def log(message):
	titi=logging.info(strftime("%a, %d %b %Y %H:%M:%S", localtime()) + " ==> " + message);
def logW(message):
	titi=logging.warning(strftime("%a, %d %b %Y %H:%M:%S", localtime()) + " ==> " + message);
def logE(message):
	titi=logging.error(strftime("%a, %d %b %Y %H:%M:%S", localtime()) + " ==> " + message);

OldCommande=""
OldConfig=""

#Ouverture fichier de config et traitement
f=open(CheminFichierConfig + "matrixConfig.txt", "r")
data=f.readlines()
f.close
words=data[0].split()
config=data[0]
MtailleX=int(str(words[1])) #Taille matrice en X
MtailleY=int(str(words[2])) #Taille matrice en Y

# Configuration de la matrice
options = RGBMatrixOptions()
options.rows = MtailleY
options.chain_length = int(MtailleX/32)+(MtailleX%32>0)
options.parallel = 1
options.hardware_mapping = 'adafruit-hat-pwm'
options.pwm_lsb_nanoseconds=300
options.scan_mode=1
options.drop_privileges = False
#options.gpio_slowdown=2
#options.pwm_bits=11
matrix = RGBMatrix(options = options)
OldConfig=config

while True:
	try:
		#Ouverture fichier de config et traitement
		f=open(CheminFichierConfig + "matrixConfig.txt", "r")
		data=f.readlines()
		f.close
		words=data[0].split()
		config=data[0]
		#si la config a changé, on relance le démon
		if config!=OldConfig:
			log(" ")
			log("--- CONFIG CHANGEE ---")
			log("Ancienne Config = "+OldConfig)
			log("Nouvelle Config = "+config)
			log("Relance Daemon")
			break
			
		#Ouverture fichier de commande et traitement
		f=open(CheminFichierCommande + "command.txt", "r")
		data = f.readlines()
		f.close()
		words=data[0].split()
		Newcommande=data[0]
		commande=str(words[1])

		### COMMANDE CLEAR ###
		if commande=='clear':
			if Newcommande!=OldCommande:
				log(" ")
				log("--- CLEAR ---")
				log("Effacement Matrice")
				
				#Liste paramètres
				log("Couleur : " + words[2].decode('utf-8'))
				log("X1 : " + words[3].decode('utf-8'))
				log("Y1 : " + words[4].decode('utf-8'))
				log("X2 : " + words[5].decode('utf-8'))
				log("Y2 : " + words[5].decode('utf-8'))
				
				#Décodage paramètres
				color=str(words[2].decode('utf-8'))
				red=ord(color.decode('hex')[0])
				green=ord(color.decode('hex')[1])
				blue=ord(color.decode('hex')[2])			
				x1=int(str(words[3].decode('utf-8')))
				if x1>MtailleX:
					x1=MtailleX			
				y1=int(str(words[4].decode('utf-8')))
				if y1>MtailleY:
					y1=MtailleY			
				x2=int(str(words[5].decode('utf-8')))
				if x2>MtailleX:
					x2=MtailleX			
				y2=int(str(words[6].decode('utf-8')))		
				if y2>MtailleY:
					y2=MtailleY		
				
				#Affichage			
				if x2==0 and y2==0:
					matrix.Clear()
					if color<>'000000':
						for a in range(0,64):
								for b in range(0,32):
									matrix.SetPixel(a,b,red,green,blue)
				else:
					for a in range(x1,x2):
							for b in range(y1,y2):
								matrix.SetPixel(a,b,red,green,blue)
				OldCommande=Newcommande
			time.sleep(1)
			
		### COMMANDE IMAGE ###
		elif commande=='image':
			if Newcommande!=OldCommande:
				log(" ")				
				log("--- IMAGE ---")
				#Liste paramètres
				log("Fichier : " + words[2].decode('utf-8'))
				log("PositionX : " + words[3].decode('utf-8'))
				log("PositionY : " + words[4].decode('utf-8'))
				log("Niveau : " + words[5].decode('utf-8'))
				log("Clear Matrix : " + words[6].decode('utf-8'))
				
				#Décodage paramètres
				NomImage=str(words[2].decode('utf-8'))
				PositionX=int(str(words[3].decode('utf-8')))
				PositionY=int(str(words[4].decode('utf-8')))
				Niveau=float(str(words[5].decode('utf-8')))
				ClearM=str(words[6].decode('utf-8'))
				
				
				#Ajout chemin absolu selon besoin
				if not ("/" in NomImage):
					NomImage=CheminDossierImages + NomImage
				
				#Initialisation affichage
				image = Image.new("RGB", (16, 32))
				#draw  = ImageDraw.Draw(image)
				image = Image.open(NomImage)
				image.load()
				image2=ImageEnhance.Brightness(image).enhance(Niveau).convert('RGB')
				
				#Affichage
				if ClearM=="1":
					matrix.Clear()	
				matrix.SetImage(image2, PositionX, PositionY)
				OldCommande=Newcommande
			#else:
			#print"Répétition -Image- non effectuée car commande statique"
			time.sleep(1)
			
		### COMMANDE SCROLLING ###
		elif commande=="scroll":
			if Newcommande!=OldCommande:
				matrix.Clear()	
				log(" ")
				log("--- TEXT SCROLL ---")		
				#Liste paramètres
				log("Taille : " + words[2].decode('utf-8'))
				log("Police : " + words[3].decode('utf-8'))
				log("Niveau : " + words[4].decode('utf-8'))
				log("Couleur : " + words[5].decode('utf-8'))
				log("Vitesse : " + words[6].decode('utf-8'))		
					
			#Décodage paramètres
			Taille=int(words[2].decode('utf-8'))
			Police=str(words[3].decode('utf-8'))
			Niveau=float(str(words[4].decode('utf-8')))
			Couleur=str(words[5].decode('utf-8'))
			Vitesse=float(words[6].decode('utf-8'))
			if Vitesse>5:
				Vitesse=5
			
			#Ajout chemin absolu selon besoin
			if not ("/" in Police):
				Police=CheminDossierPolices + Police			
			
			#Décodage message
			Message=""
			for i in range(7,len(words)):
				Message+=words[i].decode('utf-8')+" "
			Message=Message[0:len(Message)-1]
			
			#Calcul longueur image à déclarer selon police et message
			font = ImageFont.truetype(Police, Taille)
			imageTemp = Image.new("RGB", (500, MtailleY))
			drawTemp  = ImageDraw.Draw(imageTemp)	
			LargeurPixels=drawTemp.textsize(Message, font=font)
			
			#Initialisation affichage
			image = Image.new("RGB", (LargeurPixels[0], MtailleY))
			draw  = ImageDraw.Draw(image)
			PosHaut = int((MtailleY-LargeurPixels[1])/2)
			
			#Scrolling
			for x in range(0,-image.size[0]-MtailleX,-1):
				image = Image.new("RGB", (LargeurPixels[0], MtailleY))
				draw  = ImageDraw.Draw(image)
				draw.text((x+MtailleX,0), Message, font=font, fill=Couleur)
				image2=ImageEnhance.Brightness(image).enhance(Niveau)
				#image2=image2.convert('RGB')
				matrix.SetImage(image2, 0, PosHaut)
				time.sleep(0.03/Vitesse)
				matrix.Clear()
			OldCommande=Newcommande

			
		### COMMANDE SCROLLING DROITE ###
		elif commande=="scrollRight":
			if Newcommande!=OldCommande:
				#On n'écrit du log que si c'est une nouvelle commande
				log(" ")
				log("--- TEXT SCROLL RIGHT PART ---")		
				#Liste paramètres
				log("Taille : " + words[2].decode('utf-8'))
				log("Police : " + words[3].decode('utf-8'))
				log("Niveau : " + words[4].decode('utf-8'))
				log("Couleur : " + words[5].decode('utf-8'))
				log("Vitesse : " + words[6].decode('utf-8'))		
					
			#Décodage paramètres
			Taille=int(words[2].decode('utf-8'))
			Police=str(words[3].decode('utf-8'))
			NiveauTxt=float(str(words[4].decode('utf-8')))
			Couleur=str(words[5].decode('utf-8'))
			Vitesse=float(words[6].decode('utf-8'))
			if Vitesse>5:
				Vitesse=5
			
			#Ajout chemin absolu selon besoin
			if not ("/" in Police):
				Police=CheminDossierPolices + Police			
			
			#Décodage message
			Message=""
			for i in range(7,len(words)):
				Message+=words[i].decode('utf-8')+" "
			Message=Message[0:len(Message)-1]
			
			#Calcul longueur image à déclarer selon police et message
			font = ImageFont.truetype(Police, Taille)
			imageTemp = Image.new("RGB", (500, MtailleY))
			drawTemp  = ImageDraw.Draw(imageTemp)	
			LargeurPixels=drawTemp.textsize(Message, font=font)
			
			#Initialisation affichage partie scroll
			imageTxt = Image.new("RGB", (LargeurPixels[0], MtailleY))
			drawTxt  = ImageDraw.Draw(imageTxt)
			PosHaut = int((MtailleY-LargeurPixels[1])/2)
			
			#Scrolling
			for x in range(0,-imageTxt.size[0]-int(MtailleX/2),-1):
				imageTxt = Image.new("RGB", (LargeurPixels[0], MtailleY))
				drawTxt  = ImageDraw.Draw(imageTxt)
				drawTxt.text((x+int(MtailleX/2),0), Message, font=font, fill=Couleur)
				imageTxtDim=ImageEnhance.Brightness(imageTxt).enhance(NiveauTxt)
				matrix.SetImage(imageTxtDim, int(MtailleX/2), PosHaut)
				time.sleep(0.05/Vitesse)
				for a in range(int(MtailleX/2),MtailleX):
					for b in range(1,MtailleY):
						matrix.SetPixel(a,b,0,0,0)
						
			OldCommande=Newcommande


		### COMMANDE TEXTE STATIQUE ###
		elif commande=="statictext":
			if Newcommande!=OldCommande:	
				#On n'écrit du log que si c'est une nouvelle commande
				log(" ")
				log("--- STATIC TEXT ---")		
				#Liste paramètres
				log("Taille : " + words[2].decode('utf-8'))
				log("Police : " + words[3].decode('utf-8'))
				log("Niveau : " + words[4].decode('utf-8'))
				log("Couleur : " + words[5].decode('utf-8'))
				log("PositionX : " + words[6].decode('utf-8'))
				log("PositionY : " + words[7].decode('utf-8'))
					
				#Décodage paramètres
				Taille=int(words[2].decode('utf-8'))
				Police=str(words[3].decode('utf-8'))
				Niveau=float(str(words[4].decode('utf-8')))
				Couleur=str(words[5].decode('utf-8'))
				PositionX=int(str(words[6].decode('utf-8')))
				PositionY=int(str(words[7].decode('utf-8')))
				
				#Ajout chemin absolu selon besoin
				if not ("/" in Police):
					Police=CheminDossierPolices + Police			
				
				#Décodage message
				Message=""
				for i in range(8,len(words)):
					Message+=words[i].decode('utf-8')+" "
				Message=Message[0:len(Message)-1]
				
				#Calcul longueur image à déclarer selon police et message
				if ("ttf" in Police):
					font = ImageFont.truetype(Police, Taille)
				else:
					font = ImageFont.load(Police)
				imageTemp = Image.new("RGB", (500, MtailleY))
				drawTemp  = ImageDraw.Draw(imageTemp)	
				LargeurPixels=drawTemp.textsize(Message, font=font)
				
				#Initialisation affichage
				image = Image.new("RGB", (LargeurPixels[0], LargeurPixels[1]))
				draw  = ImageDraw.Draw(image)
				
				#Effacement zone d'affichage
				for a in range(0,LargeurPixels[0]):
						for b in range(0,LargeurPixels[1]):
							matrix.SetPixel(PositionX+a,PositionY+b,0,0,0)
				
				#Affichage
				image = Image.new("RGB", (LargeurPixels[0], LargeurPixels[1]))
				draw  = ImageDraw.Draw(image)
				draw.text((0,0), Message, font=font, fill=Couleur)
				image2=ImageEnhance.Brightness(image).enhance(Niveau)
				#image2=image2.convert('RGB')
				matrix.SetImage(image2, PositionX, PositionY)
				OldCommande=Newcommande
			time.sleep(1)

			
		### COMMANDE CLOCK ###
		elif commande=="clock":
			if Newcommande!=OldCommande:	
				#On n'écrit du log que si c'est une nouvelle commande
				log(" ")
				log("--- CLOCK ---")		
				#Liste paramètres
				log("Taille : " + words[2].decode('utf-8'))
				log("Police : " + words[3].decode('utf-8'))
				log("Niveau : " + words[4].decode('utf-8'))
				log("Couleur : " + words[5].decode('utf-8'))
				log("PositionX : " + words[6].decode('utf-8'))
				log("PositionY : " + words[7].decode('utf-8'))
					
			# Décodage paramètres
			Taille=int(words[2].decode('utf-8'))
			Police=str(words[3].decode('utf-8'))
			Niveau=float(str(words[4].decode('utf-8')))
			Couleur=str(words[5].decode('utf-8'))
			PositionX=int(str(words[6].decode('utf-8')))
			PositionY=int(str(words[7].decode('utf-8')))
			
			# Ajout chemin absolu selon besoin
			if not ("/" in Police):
				Police=CheminDossierPolices + Police
				
			Message=strftime("%H:%M:%S", localtime())
			
			# Calcul longueur image à déclarer selon police et message
			if ("ttf" in Police):
				font = ImageFont.truetype(Police, Taille)
			else:
				font = ImageFont.load(Police)
			imageTemp = Image.new("RGB", (500, MtailleY))
			drawTemp  = ImageDraw.Draw(imageTemp)	
			LargeurPixels=drawTemp.textsize(Message, font=font)
			
			# Initialisation affichage
			image = Image.new("RGB", (LargeurPixels[0], LargeurPixels[1]))
			draw  = ImageDraw.Draw(image)
			
			# Effacement zone d'affichage
			# for a in range(0,LargeurPixels[0]+5): #il faut déborder pour le passage de 0 à 1
					# for b in range(0,LargeurPixels[1]):
						# matrix.SetPixel(PositionX+a,PositionY+b,0,0,0)
			draw.rectangle(((PositionX, PositionY), (PositionX+LargeurPixels[0]+5, PositionY+LargeurPixels[1])), fill="black")
			matrix.SetImage(image, PositionX, PositionY)
			
			# Affichage
			image = Image.new("RGB", (LargeurPixels[0], LargeurPixels[1]))
			draw  = ImageDraw.Draw(image)
			draw.text((0,0), Message, font=font, fill=Couleur)
			image2=ImageEnhance.Brightness(image).enhance(Niveau)
			# image2=image2.convert('RGB')
			matrix.SetImage(image2, PositionX, PositionY)
			OldCommande=Newcommande
			time.sleep(1)
			
			
		#Fin commandes connues
		else:
			if Newcommande!=OldCommande:
				logW("Commande inconnue : " + commande)
				OldCommande=Newcommande
				time.sleep(1)
				
	except KeyboardInterrupt:
		break
	
	except:
		logE("Error:" + str(sys.exc_info()[0])+ str(sys.exc_info()[1])+ str(sys.exc_info()[2]))
		OldCommande=Newcommande
		time.sleep(10)				

print("    Exiting...")